#include "complex.h"
#include "memory_mgr.h"


BlockMemoryManager<Complex> ComplexMemoryManager(32);


Complex::Complex() {
  r=i=1.0;
}

Complex::Complex(double a, double b) {
  r=a;
  i=b;
}

void *Complex::operator new(size_t n) {
  return ComplexMemoryManager.allocate(n);
}

void Complex::operator delete(void *ptr) {
  ComplexMemoryManager.free(ptr);
}

void *Complex::operator new[](size_t n) {
  return ComplexMemoryManager.allocate_array(n);
}

void Complex::operator delete[](void *ptr) {
  ComplexMemoryManager.free_array(ptr);
}
